        PAGE    60,132
        TITLE   MD! 1.3 replacement for DOS MD command
Comment |

Ŀ
 MD! C:\MySub\MySub2 
 MD! C:\MySub\       
 MD! C:MySub         
 MD! MySub           
    ^watch the space 


Written in Microsoft Assembler MASM 5.0

This program is copyrighted but free.  The source and object
code may be used for any purpose except military.  You are free
to copy it, sell it, modify it, or cannibalize it.  You can take
out the credits if you want.  The only restriction, backed up by
Canadian Mind Products standard very nasty penalties is that you
must make sure none of it is ever used for a military purpose.


Please report bugs and problems to:

Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com


Version History:
================

Version 1.3 1996 October 25
- embed POB 707 Quathiaski Cove address

Version 1.2  1993/06/07
- embed new phone/address

Version 1.1  1988/05/21
Slight fixes to the comments in the MASM source code.

Version 1.0  1988/05/21  released to BIX
This is the initial version.

Version 1.1  1988/05/21
Slight fixes to the comments in the MASM source code.

Purpose
=======

MD! is very similar to the normal MS or PC DOS MD command,
however MD! is somewhat more powerful.

1.  It will automatically create higher levels of directory
    structure.
2.  It works even when when there is a trailing backslash on the
    directory name.
3.  You can redirect any error messages with >NUL:
4.  If a file already exists by that name, (nearly always
    created by by a failed file copy to a non-existent subdirectory)
    the file is automatically deleted and the directory is made in its
    place.
5.  MD! sets ERRORLEVEL if it fails.

MD! is slower than MD since it is must be loaded each time,
whereas MD is internal to DOS.

Notes an How MD! Works
======================

MD! parses the command line looking for a subdirectory name.

If there is no name we exit with errorlevel 1.

From this we construct the entire name of the subdirectory.  It
may be missing the leading C: or leading \.  We add a trailing
trailing backslash if there is not one there already.

If there is no name following the C:\ we exit with errorlevel 1.

For each level of the structure we use FIND FIRST 4E to find out
what sort of thing exists already by that name.

If it is already a directory, we are fine.

If it is a file, we delete it. 41h, then create the directory
49h.

If it is a read-only file we remove read-only status 43h and
delete it. 41h, then create the directory 49h.

IF it does not exist, we create it as a directory. 49h, then
create the directory 49h.

If the 49h make directory fails we exit with an errorlevel 1

| ; End of long comment

; M A C R O S

CR      MACRO   ; Carriage return line feed
        DB 0dh,0ah
        ENDM

;======

EOS     MACRO   ; marks end of display string
        DB 0dh,0ah,'$'
        ENDM

;======

CODE    SEGMENT PARA

        ASSUME  CS:CODE,DS:CODE,ES:CODE
        ORG     100H

;======================================
Start:  JMP     Main
;======================================
;       REGISTER CONVENTIONS
;       all registers are trashable in calls except BX CX and DI
;       BX always points to the start of the command string.
;       CX always counts number of chars in the command string.
;       DI contains start of subdirectory name proper bypassing
;       lead C:\
;       Because this is a com file, all segment registers are
;       stable equal to CS:
;======================================
SAY     MACRO   Msg
;       display message on screen
        LEA     DX,&Msg         ; use LEA rather than
                                ; MOV Offset for more generality
        MOV     AH,09h
        INT     21h
        ENDM
;======================================
        EVEN
DTA     LABEL   BYTE            ; disk transfer area
                                ; Used in Find First Match
        DB      21 DUP (0)      ; reserved for DOS
Fattrib DB      0               ; attribute byte
FTime   DW      0               ; file Time in directory form
FDate   DW      0               ; file Date in directory form
FSize   DW      0               ; 32 bit file size
        DW      0
FName   DB      13 DUP(0)       ; file name and extension

;========================================
CantMsg         LABEL   BYTE
        DB      'Unable to create directory'
        DB      13,10,"$"
;========================================
MLeading        PROC    Near
;       on entry BX is addr of string, CX its length
;       trims off any leading blanks, leaving result in BX CX
;       length may also be 0 or 1, but not -ve
;       If the entire string is blank the result is the null string
        MOV     DI,BX
        MOV     AL,20h          ; AL = blank  -- the search char
        JCXZ    MLEADING2       ; jump if null string
        REPE    SCASB           ; scan ES:DI forwards till hit non blank
                                ; DI points just after it (wrap ok)
                                ; CX is one too small, or 0 if none found
        JE      MLEADING1       ; jump if entire string was blank
        INC     CX              ; CX is length of remainder of string
MLEADING1:
        DEC     DI              ; DI points to non-blank
MLEADING2:
        MOV     BX,DI           ; put address back
        RET
MLeading        ENDP
;========================================
MTrailing       PROC    Near
;       on entry BX is addr of string, CX its length
;       trims off any trailing blanks, leaving result in BX CX
;       length may also be 0 or 1, but not -ve
;       If the entire string is blank the result is the null string
        MOV     DI,BX
        ADD     DI,CX           ; calc addr last char in string
        DEC     DI
        MOV     AL,20h          ; AL = blank  -- the search char
        JCXZ    MTRAILING1      ; jump if null string
        STD
        REPE    SCASB           ; scan ES:DI backwards till hit non blank
                                ; DI points just ahead of it (wrap ok)
                                ; CX is one too small, or 0 if none found
        CLD
        JE      MTRAILING1      ; jump if whole string was blank
        INC     CX
MTRAILING1:
        RET
MTrailing       ENDP
;========================================;====
Parse   PROC    NEAR
;       Parse the command line to remove lead/trail blanks
;       and terminate by 2 nulls.
;       sample inputs
;       MD!     C:\MySub\MySub2\
;       MD! MySub2
;       MD!
;       MD!  D:\
;       MD!  D:
;
;       When Done DS:BX points to start of string.
;       String will be terminated by 2 nulls
;       CX counts bytes in string exclusive of nulls
                                ; counted string at HEX 80 PSP
                                ; contains command line.
                                ; Preceeded by unwanted spaces.
                                ; possibly followed by unwanted spaces.
                                ; currently missing a trailing null.
        XOR     CH,CH
        MOV     CL,DS:80h
        MOV     BX,81h
        CALL    Mleading        ; get rid of leading blanks
        CALL    MTrailing       ; get rid of trailing blanks
        MOV     DI,BX           ; calc addr of byte just past end
        ADD     DI,CX
        MOV     WORD PTR [DI],0 ; plop in pair of nulls after string
        RET
Parse   ENDP
;=======================================
StripDrive      PROC    Near
;
;       Remove leading drive C: if any
;       C:\SUB1\SUB2\SUB3
;       ^ ^             ^
;       a b             c
;       input   DS:BX=a CX=length a..c
;       results DS:BX=a DI=b CX=length b..c
        MOV     DI,BX
        CMP     BYTE PTR [DI+1],':'
        JNE     HasNoDrive
        ADD     DI,2
        SUB     CX,2
HasNoDrive:
        RET
StripDrive      ENDP
;=======================================
StripLeadSlash  PROC    Near
;       Remove leading drive \ if any
;       C:\SUB1\SUB2\SUB3
;       ^ ^^            ^
;       a bc            d
;       input   DS:BX=a DI=b CX=length b..d
;       results DS:BX=a DI=c CX=length c..d
;
        CMP     BYTE PTR [DI],'\'
        JNE     HasNoLeadSlash
        INC     DI
        DEC     CX
HasNoLeadSlash:
        RET
StripLeadSlash  ENDP
;=======================================
AddTrailSlash   PROC    Near
;       Add trail slash if needed
;       C:\SUB1\SUB2\SUB3\
;       ^ ^^            ^^
;       a bc            de
;       input   DS:BX=a DI=c CX=length c..d
;       results DS:BX=a DI=c CX=length c..e
;
        PUSH    DI
        ADD     DI,CX
        DEC     DI                      ; point to \ at end
        MOV     AL,'\'
        SCASB
        JE      AlreadyHasSlash
        MOV     BYTE PTR [DI],AL        ; DI point one past end
        INC     CX
AlreadyHasSlash:
        POP     DI
        RET
AddTrailSlash   ENDP
;=======================================
NoNulls PROC    Near
;       Avoid attempting to handle null subdirectories
;       e.g. C: C:\ \ null
;       which will appear at this point as
;       C:\     CX=1
;       C:\\    CX=1
;       \\      CX=1
;       \       CX=1
;       C:\SUB1\SUB2\SUB3\
;       ^ ^^            ^^
;       a bc            de
;       input DS:BX=a DI=c CX=length c..e
        CMP     CX,1
        JLE     Die
        RET
NoNulls ENDP
;=======================================
Bye     PROC    NEAR
;       Return to DOS with 0 ERRORLEVEL
        MOV     AX,4C00h        ; quit with 0 errorlevel
        INT     21h
Bye     ENDP
;======================================
Die     PROC    NEAR
        Say     CantMsg
;       Fatal error -- give up and return to DOS with ERRORLEVEL=1
        MOV     AX,4C01h        ; die with 1 errorlevel
        INT     21h
Die     ENDP
;=======================================
WhatIs  PROC    NEAR
;       find out what kind of file whose asciiz name is in DS:BX
;       Results:
;       AX=0 nothing
;       AX=1 plain file
;       AX=2 r/o file
;       AX=3 directory (poss read/only)
;       AX=4 something else
        PUSH    CX
        MOV     DX,offset DTA
        MOV     AH,1Ah          ; set up DTA for DOS to report its findings
        INT     21h
        MOV     DX,BX
        MOV     CX,0FFh         ; find everything by
                                ; that name
                                ; 01 bit 0 = RO
                                ; 02 bit 1 = hidden
                                ; 04 bit 2 = system
                                ; 08 bit 3 = volume label
                                ; 10 bit 4 = subdir
                                ; 20 bit 5 = archive
        MOV     AH,4Eh
        INT     21h             ; find first
                                ; STC notes trouble
                                ; DTA contains results
;       AX=0 nothing
        MOV     AX,0
        JC      WhatIsDone
;       AX=1 plain file
        MOV     AX,1
        MOV     DL,Fattrib
        AND     DL,10h+08h+04h+01h
        JZ      WhatIsDone
;       AX=2 r/o file
        MOV     AX,2
        MOV     DL,Fattrib
        AND     DL,10h+08h+04h
        JZ      WhatIsDone
;       AX=3 directory (poss read/only)
        MOV     AX,3
        MOV     DL,Fattrib
        AND     DL,08h+04h
        JZ      WhatIsDone
;       AX=4 something else
        MOV     AX,4
WhatIsDone:
        POP     CX
        RET
WhatIs  ENDP
;=======================================
Mk1Dir  PROC    NEAR
;       create one level of directory whose asciiz name is in DS:BX
        MOV     DX,BX
        MOV     AH,39h                  ; create the subdirectory
        INT     21h
        JNC     Mk1Ok
        CALL    Die                     ; did not work
Mk1Ok:  RET
Mk1Dir  ENDP
;======================================
RidRO   PROC    NEAR
;       get rid of file whose asciiz name is in DS:BX
;       get rid of read only status and delete it.
        PUSH    CX
        PUSH    BX
        MOV     DX,BX
        XOR     CX,CX                   ; CX=attrib
        MOV     AX,4301h                ; change attribute to vanilla
        INT     21h
        MOV     AH,41h                  ; delete it
        INT     21h
        POP     BX
        POP     CX
        RET
RidRO   ENDP
;=======================================================
RidFile PROC    NEAR
;       get rid of file whose asciiz name is in DS:BX
        MOV     DX,BX
        MOV     AH,41h                  ; delete it
        INT     21h
        RET
RidFile ENDP
;=======================================================
Case0   PROC    Near
;       Handles case 0
;       AX=0 nothing
        Call    Mk1Dir
        RET
Case0   ENDP
;=======================================
Case1   PROC    Near
;       Handles case 1
;       AX=1 plain file
        Call    RidFile
        Call    Mk1Dir
        RET
Case1   ENDP
;=======================================
Case2   PROC    Near
;       Handles case 2
;       AX=2 r/o file
        Call    RidRO
        Call    Mk1Dir
        RET
Case2   ENDP
;=======================================
Case3   PROC    Near
;       Handles case 3
;       AX=3 directory (poss read/only)
;       nothing to do
        RET
Case3   ENDP
;=======================================
Case4   PROC    Near
;       Handles case 4
;       AX=4 something else
        Call    Die
        RET
Case4   ENDP
;=======================================
Cases   PROC    Near
;       handle all cases by call Case[DX]
;       on entry DX contains case#
;       AX=0 nothing
;       AX=1 plain file
;       AX=2 r/o file
;       AX=3 directory (poss read/only)
;       AX=4 something else
        MOV     SI,AX           ; Call Case[DX]
        SHL     SI,1
        Call    CaseTable[SI]
        RET
CaseTable       LABEL   WORD
        DW      offset Case0
        DW      offset Case1
        DW      offset Case2
        DW      offset Case3
        DW      offset Case4
Cases   ENDP
;======================================
MkDirs  PROC    NEAR
;       DS:BX contains the directory name to create a..c
;       CX contains length of string string b..c
;       DI points to first letter of subdirectory name proper - b
;             a  b             c
;       e.g.  C:\SUB1\SUB2\SUB3\
;       We build all the necessary subdirectories
;       C:\SUB1
;       C:\SUB1\SUB2
;       C:\SUB1\SUB2\SUB3

        MOV     AL,'\'
MakeMoreDirs:
        JCXZ    MkDirsDone
        REPNE   SCASB                   ; scan for a \
        JNE     MkDirsDone              ; jump if didn't find one
        MOV     BYTE PTR [DI-1],0       ; temporarily change it to null
        CALL    WhatIs
        CALL    Cases
        MOV     AL,'\'
        MOV     [DI-1],AL               ; put null back to \
        JMP     MakeMoreDirs
MkDirsDone:
        RET
MkDirs  ENDP
;======================================
MAIN    PROC
        CALL    Parse           ; parse command line
                                ; DS:BX contains ASCIIZ string
                                ; stripped of lead/trail blanks
        CALL    StripDrive      ; bypass lead C:
        Call    StripLeadSlash  ; bypass lead \
        CALL    AddTrailSlash   ; add trail backslash if not there
        CALL    NoNulls         ; filter out C:\ C: \ null
        CALL    MkDirs          ; make each level of directory
        JMP     Bye             ; return to DOS
MAIN    ENDP
;======================================

CopyrightMsg    label byte      ; does not display
        CR
        DB      ' MD! 1.3 ۲'
        CR
        DB      'Freeware to create directories.'
        CR
        DB      'usage:  MD!  C:\Mysub1\MySub2'
        CR
        DB      'Copyright (c) 1988, 1996 Roedy Green Canadian Mind Products'
        CR
        DB      '#208 - 525 Ninth Street, New Westminster, BC Canada V3M 5T9',13,10
        DB      'tel:(604) 777-1804   mailto:roedy@mindprod.com   http://mindprod.com',13,10
        DB      'May be freely distributed and used for any purpose except military.'
        EOS

CODE    ENDS
        END     Start
